#! /usr/bin/python
import pygtk, gtk, time, os, sys, gettext
pygtk.require("2.0")
gettext.textdomain('TMLauncher')
_ = gettext.gettext


class TM_Launcher:
	def __init__(self):
		interface = gtk.Builder()
		interface.set_translation_domain('TMLauncher')
		interface.add_from_file('/usr/share/TMLauncher/TMLauncher.glade')
		self.dialogApropos = interface.get_object("dialogApropos")
		self.myLabel = interface.get_object("myLabel")
		self.valueDelai = interface.get_object("valueDelai")
		self.valueFormat = interface.get_object("valueFormat")
		self.valueFormat.set_active(0)
		self.valueChanels = interface.get_object("valueChanels")
		self.adjustmentChanels = interface.get_object("adjustmentChanels")
		self.adjustmentChanels.set_upper(6)
		self.valueName = interface.get_object("valueName")
		self.labelOutputFile = interface.get_object("labelOutputFile")
		self.fileDestination = os.environ['HOME']+"/"+time.strftime("%A_%d_%B_%Y_%H%M%S", time.gmtime())+"."+self.valueFormat.get_active_text()
		self.labelOutputFile.set_text(_("Output file :")+self.fileDestination)
		interface.connect_signals(self)
		self.valueDelai.set_value(15)
		self.valueChanels.set_value(2)

	def on_valueFormat_changed(self, widget):
		if (self.valueFormat.get_active_text() == "wav"):
			self.adjustmentChanels.set_upper(6)
		else:
			self.adjustmentChanels.set_upper(8)

	def on_Apropos_activate(self, widget):
		self.dialogApropos.show()
	def on_dialogApropos_response(self, widget, destroy):
		self.dialogApropos.hide()

	def on_filechooserbutton_clicked(self, widget):
		self.filechooserbutton = gtk.FileChooserDialog(_("Save as..."), None, gtk.FILE_CHOOSER_ACTION_SAVE, ((gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_SAVE, gtk.RESPONSE_OK)))
		self.filechooserbutton.set_do_overwrite_confirmation(True)
		self.response = self.filechooserbutton.run()
		if self.response == gtk.RESPONSE_OK:
			self.fileDestination = self.filechooserbutton.get_filename()
		self.filechooserbutton.destroy()
		self.labelOutputFile.set_text(_("Output file :")+self.fileDestination)

	def on_MainWindow_destroy(self, widget):
		gtk.main_quit()
		exit(0)
	def on_Annuler_clicked(self, widget):
		gtk.main_quit()
		exit(0)

	def on_Appliquer_clicked(self, widget):
		if (os.path.exists('/usr/bin/timemachine')):
			os.execl('/usr/bin/timemachine', 'timemachine', '-c', str(int(self.valueChanels.get_value())), '-n', self.valueName.get_text(), '-t', str(int(self.valueDelai.get_value())), '-p', self.fileDestination, '-f', self.valueFormat.get_active_text())
			gtk.main_quit()
			exit(0)
		else:
			gtk.main_quit()
			self.errordialog = gtk.MessageDialog(None, 0, gtk.MESSAGE_ERROR, gtk.BUTTONS_CLOSE, _("'/usr/bin/timemachine' not found, closing program"))
			self.errordialog.run()
			self.errordialog.destroy()
			exit(-1)

if __name__ == "__main__":
	TM_Launcher()
	gtk.main()
